#include "25LC080.h"

uint8_t eepromReadByte(uint16_t address) {
	SS_LOW;
	spiTransfer(_25LC080_READ);
	spiTransfer(address >> 8);
	spiTransfer(address);
	uint8_t data = spiTransfer(0);
	SS_HIGH;
	return data;
}

void eepromReadBytes(uint16_t address, uint8_t data[], uint16_t size) {
	SS_LOW;
	spiTransfer(_25LC080_READ);
	spiTransfer(address >> 8);
	spiTransfer(address);
	for (uint16_t i = 0; i < size; i++) {
		data[i] = spiTransfer(0);
	}
	SS_HIGH;
}

void eepromWriteByte(uint16_t address, uint8_t data) {
	eepromWriteEnable();
	SS_LOW;
	spiTransfer(_25LC080_WRITE);
	spiTransfer(address >> 8);
	spiTransfer(address);
	spiTransfer(data);
	SS_HIGH;
}

void eepromWriteBytes(uint16_t address, uint8_t data[], uint16_t size) {
	eepromWriteEnable();
	SS_LOW;
	spiTransfer(_25LC080_WRITE);
	spiTransfer(address >> 8);
	spiTransfer(address);
	for (uint16_t i = 0; i < size; i++) {
		spiTransfer(data[i]);
	}
	SS_HIGH;
}

uint8_t eepromReadStatus(void) {
	SS_LOW;
	spiTransfer(_25LC080_RDSR);
	uint8_t data = spiTransfer(0);
	SS_HIGH;
	return data;
}

void eepromWriteStatus(uint8_t data) {
	eepromWriteEnable();
	SS_LOW;
	spiTransfer(_25LC080_WRSR);
	spiTransfer(data);
	SS_HIGH;
}

void eepromWriteEnable(void) {
	SS_LOW;
	spiTransfer(_25LC080_WREN);
	SS_HIGH;
}

void eepromWriteDisable(void) {
	SS_LOW;
	spiTransfer(_25LC080_WRDI);
	SS_HIGH;
}

uint8_t eepromIsBusy(void) {
	if (eepromReadStatus() & _BV(_25LC080_WIP)) return 1; else return 0;
}