#include <avr/io.h>
#include <util/delay.h>
#include "spi.h"
#include "25LC080.h"
#include "lcd.h"

uint8_t testWrite(uint8_t expected);

int main(void) {
	spiInit();
	lcdInit();
	lcdInitPrintf();
	//wycz ochron
	eepromWriteStatus(0);
	while (eepromIsBusy()) _delay_ms(1);
	printf(testWrite(12) ? "OK" : "ERR");
	lcdGotoXY(0, 1);
	//wcz ochron
	eepromWriteStatus(_BV(_25LC080_BP1) | _BV(_25LC080_BP0));
	while (eepromIsBusy()) _delay_ms(1);
	printf(testWrite(34) ? "OK" : "ERR");
	while(1){ }
}

uint8_t testWrite(uint8_t expected) {
	eepromWriteByte(0, expected);
	while (eepromIsBusy()) _delay_ms(1);
	return (eepromReadByte(0) == expected);
}